// TeXworksScript
// Title:  Get Translation (Experimental - Windows Only)
// Description: One Language to Another Small portions
// Author:  Paul Norman
// Version: 0.1
// Date: 2011-02-15
// Script-Type: standalone
// Context: TeXDocument
// Shortcut: Alt+G, Alt+T

// Install: unzip into any folder under your Tw scripts folder, overwrite any previous version.

// Update:  From  -  http://TwScript.PaulANorman.com/downloads/?GetTrans

// Needed: Turn on Tw Menu: Edit/Preferences/Scripts and tick "allow scripts to run System commands".
//         Open Internet access.

// Usage: Highlight a block of text, a few small paragraphs or one big one.
//        Run Script, choose languages (these will be remembered for current Tw editing session).
//        Maximum of 1500 characters at a time will be processed - will be clearly marked in results.
//        Result is slightly preprocessed for LaTeX requirements.
//        Use Crtl-Z immediately to reverse results and re-mark for another try if necessary.
//        (Google's total daily combined limit for all TeXworks users of thjis Script 
//        is presently 100,000 characters on days that this is exceeded, 
//        script won't work).

// BE AWARE: Your IP address is used to limit phishing of the service.

// WARNING: Save your work first and in all respects Use at Own Risk and Your Full Responsibility! 
//          All care and no responsibility on my part.

// Notes: Useful for occasions when just a paragraph or two is needed for immediate 
//        initial translation.   --  Windows only at this stage.
//        twSctiptLanguage.php is used server side (provided for reference)
//                             the security key's path is obscured in that file.

// MUST: if used, give credit somewhere in public view in document to Google, with the words:
//       "Powered by Google"

  eval(TW.app.getGlobal("helper_twPan")); //  Comment if NOT Needed - This includes PhpJs ($P), twConst, msgBox, twPan ($tw), string.toTitleCase() 
  
  

  displayNames = [];
  nameCodes = [];
  chosenElements = {"L0": "13", "L1" : "13"}; // default to English key index for both
  chosenCodes = [];


  if (TW.script.hasGlobal("chosenElements"))
    {
      chosenElements = JSON.parse(TW.script.getGlobal("chosenElements")); // pick up last chosen languages array positions for later getItem()
     }

// http://code.google.com/apis/language/translate/v1/reference.html#translatableLanguages
// http://code.google.com/apis/language/translate/v1/using_rest_translate.html#request_format

 function restoreUtf(codes)
   {
   var build = "";
   
     codes = codes.split(",");
       for (code in codes)
         {
           build += String.fromCharCode(codes[code]);
                  
          }
       return build;   
    }

 function determineKey(lookTroughArray, elementString)
  {
        
     if (elementString != undefined)
       { 
        for (key in lookTroughArray)
           {
            if (elementString == lookTroughArray[key])
              {
               return key;
               } 
             
             }
       }      
         return -1;
   }

  languageList = TW.readFile("GoogleSupportedLanguages.csv").result;
  
  languageList = languageList.split("\n");
  
    for (line in languageList)
       {
         if (languageList[line].substr(0,1) != "%")
           {
             build = languageList[line].split(",");
               
               fixName = build[0].substr(0,1).toUpperCase() + build[0].substr(1).toLowerCase();
               
               displayNames.push(fixName);
			   nameCodes[fixName] = build[1];
            }
        }  
        
        var title = "Start Language (From)";
        var choose = 0;
        
        do
          {  
              var chosenLanguageName =  TW.getItem(null, title, title, displayNames, chosenElements["L" + choose], false);
          
           chosenElements["L" + choose]  = determineKey(displayNames, chosenLanguageName); // store chosen langauge key number
          
            chosenCodes[choose] =  nameCodes[chosenLanguageName];
            title = "Into Language (Result)";
            choose++;
          }
          while (choose < 2)
          
      TW.script.setGlobal("chosenElements" , JSON.stringify(chosenElements)); //save chosen languages array positions for later getItem()  
          
          
       var   originalText =  TW.target.selection + " ";
       
       if (originalText != " ")
         {
         
         selLength = originalText.length;
         var orginalSelectionLength = selLength;
         
     //    twPan.alert(selLength);
         
          if (selLength > 1499)
             {  selLength = 1500;}
           
           
           var selStart = TW.target.selectionStart;
               
               // Try and make sure we are not breaking a word or connected ideograph
               do
                 {
                 TW.target.selectRange(selStart, selLength);
                 
                 originalText =  TW.target.selection;
                 
                 selLength--;
                 
                 lastChar = originalText.substr(originalText.length -1,1);
                
                   }
                   // Now find logical ending of portion of text
                  while(    lastChar != " " 
                         && lastChar != "." 
                         && lastChar != "," 
                         && lastChar != ";" 
                         && lastChar != ":" 
                         && lastChar != "?" 
                         && lastChar != "!" 
                         && selLength > 1 
                       );  

                 if (originalText.length > 1)
                   {
                     
                var readiedText =    "\"" + encodeURIComponent(originalText) + "\"";
                
                
                scriptPath = __FILE__.substr(0, __FILE__.lastIndexOf("/") +1);
               
                
           switch (TW.platform())     
            {
            
              case "Windows":       
                              commandString = "cmd /c cscript //nologo " 
                                             + scriptPath 
                                             + "doTranslation.js " 
                                             + readiedText 
                                             + " " + chosenCodes[0] 
                                             + " " +  chosenCodes[1] ;                          
                  
                       var  returnedCodes  =  TW.system(commandString, true).output;    
            
                        var   convertedToUnicode = restoreUtf(returnedCodes);             
                         objectCode = convertedToUnicode.substr(convertedToUnicode.indexOf("{"));
     
                       objectCode = objectCode.substr(0, objectCode.lastIndexOf("}") +1);
                       
                   break;
              
              case "MacOSX":
                     
                     retObj = {"error": {"message": "Sorry, Not Ready for MacOSX Yet"}};
                  
                   break;
                   
              case "X11":
                   
                     retObj = {"error": {"message": "Sorry, Not Ready for Linux Yet"}};
              
                   break;
                   
              case "unkown":
                    default:
               retObj = {"error": {"message": "Sorry, Your OS is unknown"}};
               break;     
                                                                                                                                                
           }                                                                          

          
          
      retObj = JSON.parse(objectCode);
        
                if (retObj.error) 
                  {
                    TW.critical(null, "Tw Message", retObj.error.message + "\n\nPlease Try Again");
                  }  
              else
                  {
                  
                translatedText = retObj.data.translations[0].translatedText;
                   
                    
                escapeList = [ "\\\\", "#", "\\$", "%", "&", "~", "_", "\\^", "{", "}"]  ;
                
                  for (escapee in escapeList)
                     {
                         buildReg = new RegExp( escapeList[escapee],"g");
                         
                         translatedText = translatedText.replace(buildReg,"\\" + escapeList[escapee]);
                                              
                      }                        
                                                        
                   TW.target.insertText(originalText + "\n\nExperimental TwScript (tried to process "+orginalSelectionLength+" / maximum 1500 chars - cut back to: "+ selLength +" ) - Updates From:\n  http://TwScript.PaulANorman.com/downloads/?GetTrans \n\nTranslated by Google Api  \n\n-- Mention in Credits--->``Powered by Google\'\'\n\n" + translatedText + "\n\n <---Translation Ends\n\n"); 
                   }   
                     }
                       } 
  null;
	
	 /*
  Dual licensed under the

GPL (http://www.gnu.org/licenses/old-licenses/gpl-2.0.html)
http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

Copyright (c) 2010,2011 Paul A Norman and others in their own right


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

MIT (http://www.opensource.org/licenses/mit-license.php)

Copyright (c) 2010,2011 Paul A Norman and others in their own right

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal in the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL PAUL ANTHONY NORMAN BE LIABLE FOR ANY CLAIM, DAMAGES
 OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN EITHER THE SOFTWARE OR DOCUMENTATION.

*/